package com.gx.obe.evaluation.struct.enumeration;

import java.util.Arrays;
import java.util.Optional;
import java.util.Set;
import java.util.function.Predicate;
import java.util.stream.Collectors;

import com.gx.obe.util.utils.PredicateUtil;

/**
 * @Description: 结构化技术类型
 * @author chenxw
 */
public enum StructTechnologyTypeEnum {
	
	/**
	 * null
	 */
	NULL("null", ""),
	
	/**
	 * 主要技术参数1
	 */
	PARAM_1("Param1", "主要技术参数1"),
	/**
	 * 主要技术参数2
	 */
	PARAM_2("Param2", "主要技术参数2"),
	/**
	 * 主要技术参数3
	 */
	PARAM_3("Param3", "主要技术参数3"),
	/**
	 * 主要技术参数4
	 */
	PARAM_4("Param4", "主要技术参数4"),
	/**
	 * 主要技术参数5
	 */
	PARAM_5("Param5", "主要技术参数5"),
	/**
	 * 主要技术参数6
	 */
	PARAM_6("Param6", "主要技术参数6"),
	/**
	 * 主要技术参数7
	 */
	PARAM_7("Param7", "主要技术参数7"),
	/**
	 * 主要技术参数8
	 */
	PARAM_8("Param8", "主要技术参数8"),
	/**
	 * 主要技术参数9
	 */
	PARAM_9("Param9", "主要技术参数9"),
	/**
	 * 主要技术参数10
	 */
	PARAM_10("Param10", "主要技术参数10"),
	/**
	 * 主要技术参数10
	 */
	PARAM_11("Param11", "主要技术参数11"),
	/**
	 * 主要技术参数10
	 */
	PARAM_12("Param12", "主要技术参数12"),
	/**
	 * 主要技术参数10
	 */
	PARAM_13("Param13", "主要技术参数13"),
	/**
	 * 主要技术参数10
	 */
	PARAM_14("Param14", "主要技术参数14"),
	/**
	 * 主要技术参数10
	 */
	PARAM_15("Param15", "主要技术参数15");
	
	private final String key;
	private final String value;
	
	private StructTechnologyTypeEnum(String key, String value) {
		this.key = key;
		this.value = value;
	}
	
	public String getKey() {
		return key;
	}
	
	public String getValue() {
		return value;
	}
	
	private static Set<String> keySet = Arrays.stream(values()).map(StructTechnologyTypeEnum::getKey).filter(Predicate.isEqual(NULL.getKey()).negate()).collect(Collectors.toSet());
	
	/**
	 * @Description:
	 * @author chenxw
	 * @param object
	 * @return
	 */
	public static Optional<StructTechnologyTypeEnum> getBykey(String key) {
		return Arrays.stream(values()).filter(PredicateUtil.get(StructTechnologyTypeEnum::getKey, Predicate.isEqual(key))).findAny();
	}
	
	/**
	 * @Description:
	 * @author chenxw
	 * @param key
	 * @return
	 */
	public static boolean contains(String key) {
		return keySet.contains(key);
	}
	
}
